import numpy

from algorithm.decision_tree.decision_tree import DecisionTree
from aufgaben.p4.testdata import get_labeled_testdata
from aufgaben.p6.error_rate import ErrorRate


def apply_decision_tree():
    test_data, training_data = get_labeled_testdata()

    # Trainiere den Decision Tree
    algorithm = DecisionTree(entropy_threshold=0.5, number_segments=10)
    algorithm.train(training_data)

    # Vergleiche alle Ergebnisse mit der erwarteten Klasse
    fehlerrate = ErrorRate()
    for features, correct_class in test_data:
        result = algorithm.classify(features)
        fehlerrate.evaluate(correct_class, result)
    fehlerrate.print_table()

    algorithm.tree.print_tree()


if __name__ == '__main__':
    apply_decision_tree()
